Index: CMakeLists.txt
===================================================================
--- CMakeLists.txt	(revision c3c9ac56bcd38b9487ed3bdd295d5b9c0606f3e6)
+++ CMakeLists.txt	(revision f6b6ee7f127179b618ac5b4e3d7440af180c9dc1)
@@ -7,5 +7,5 @@
 
 # Declare ROOT dependency
-find_package(ROOT COMPONENTS EG Eve GenVector Hist Physics Matrix Graf RIO Tree Gpad RGL MathCore)
+find_package(ROOT COMPONENTS EG Eve Geom Gui GuiHtml GenVector Hist Physics Matrix Graf RIO Tree Gpad RGL MathCore)
 include(${ROOT_USE_FILE})
 
Index: Makefile
===================================================================
--- Makefile	(revision c3c9ac56bcd38b9487ed3bdd295d5b9c0606f3e6)
+++ Makefile	(revision f6b6ee7f127179b618ac5b4e3d7440af180c9dc1)
@@ -17,23 +17,23 @@
 CXXFLAGS += $(ROOTCFLAGS) -Wno-write-strings -D_FILE_OFFSET_BITS=64 -DDROP_CGAL -I. -Iexternal -Iexternal/tcl
 DELPHES_LIBS = $(shell $(RC) --libs) -lEG $(SYSLIBS)
-DISPLAY_LIBS = $(shell $(RC) --evelibs) $(SYSLIBS)
+DISPLAY_LIBS = $(shell $(RC) --evelibs) -lGuiHtml  $(SYSLIBS)
 
 ifneq ($(CMSSW_FWLITE_INCLUDE_PATH),)
 HAS_CMSSW = true
 CXXFLAGS += -std=c++0x -I$(subst :, -I,$(CMSSW_FWLITE_INCLUDE_PATH))
-DELPHES_LIBS += -L$(subst include,lib,$(subst :, -L,$(CMSSW_FWLITE_INCLUDE_PATH)))
+OPT_LIBS += -L$(subst include,lib,$(subst :, -L,$(CMSSW_FWLITE_INCLUDE_PATH)))
 ifneq ($(CMSSW_RELEASE_BASE),)
 CXXFLAGS += -I$(CMSSW_RELEASE_BASE)/src
 endif
 ifneq ($(LD_LIBRARY_PATH),)
-DELPHES_LIBS += -L$(subst include,lib,$(subst :, -L,$(LD_LIBRARY_PATH)))
-endif
-DELPHES_LIBS += -lGenVector -lFWCoreFWLite -lDataFormatsFWLite -lDataFormatsPatCandidates -lDataFormatsLuminosity -lSimDataFormatsGeneratorProducts -lCommonToolsUtils
+OPT_LIBS += -L$(subst include,lib,$(subst :, -L,$(LD_LIBRARY_PATH)))
+endif
+OPT_LIBS += -lGenVector -lFWCoreFWLite -lDataFormatsFWLite -lDataFormatsPatCandidates -lDataFormatsLuminosity -lSimDataFormatsGeneratorProducts -lCommonToolsUtils
 endif
 
 ifneq ($(PROMC),)
 HAS_PROMC = true
-CXXFLAGS += -I$(PROMC)/include
-DELPHES_LIBS += -L$(PROMC)/lib -lprotoc -lprotobuf -lprotobuf-lite -lcbook -lz
+CXXFLAGS += -I$(PROMC)/include -I$(PROMC)/src
+OPT_LIBS += -L$(PROMC)/lib -lpromc -lprotoc -lprotobuf -lprotobuf-lite -lcbook -lz
 endif
 
@@ -41,12 +41,15 @@
 HAS_PYTHIA8 = true
 CXXFLAGS += -I$(PYTHIA8)/include
-DELPHES_LIBS += -L$(PYTHIA8)/lib -lpythia8 -lLHAPDF -lgfortran -lz
+OPT_LIBS += -L$(PYTHIA8)/lib -lpythia8 -lLHAPDF -lgfortran -lz
 else
 ifneq ($(PYTHIA8DATA),)
 HAS_PYTHIA8 = true
 CXXFLAGS += -I$(PYTHIA8DATA)/../include
-DELPHES_LIBS += -L$(PYTHIA8DATA)/../lib -lpythia8 -lLHAPDF -lgfortran -lz
-endif
-endif
+OPT_LIBS += -L$(PYTHIA8DATA)/../lib -lpythia8 -lLHAPDF -lgfortran -lz
+endif
+endif
+
+DELPHES_LIBS += $(OPT_LIBS)
+DISPLAY_LIBS += $(OPT_LIBS)
 
 ###
@@ -238,6 +241,5 @@
 	external/ExRootAnalysis/ExRootTreeWriter.h \
 	external/ExRootAnalysis/ExRootTreeBranch.h \
-	external/ExRootAnalysis/ExRootProgressBar.h \
-	external/ProMC/ProMCBook.h
+	external/ExRootAnalysis/ExRootProgressBar.h
 EXECUTABLE +=  \
 	DelphesProMC$(ExeSuf)
@@ -245,26 +247,4 @@
 EXECUTABLE_OBJ +=  \
 	tmp/readers/DelphesProMC.$(ObjSuf)
-
-tmp/external/ProMC/ProMCBook.$(ObjSuf): \
-	external/ProMC/ProMCBook.$(SrcSuf)
-tmp/external/ProMC/ProMC.pb.$(ObjSuf): \
-	external/ProMC/ProMC.pb.$(SrcSuf)
-tmp/external/ProMC/ProMCStat.pb.$(ObjSuf): \
-	external/ProMC/ProMCStat.pb.$(SrcSuf)
-tmp/external/ProMC/ProMCHeader.pb.$(ObjSuf): \
-	external/ProMC/ProMCHeader.pb.$(SrcSuf)
-tmp/external/ProMC/ProMCDescription.pb.$(ObjSuf): \
-	external/ProMC/ProMCDescription.pb.$(SrcSuf)
-DELPHES_OBJ +=  \
-	tmp/external/ProMC/ProMCBook.$(ObjSuf) \
-	tmp/external/ProMC/ProMC.pb.$(ObjSuf) \
-	tmp/external/ProMC/ProMCStat.pb.$(ObjSuf) \
-	tmp/external/ProMC/ProMCHeader.pb.$(ObjSuf) \
-	tmp/external/ProMC/ProMCDescription.pb.$(ObjSuf)
-
-ifeq ($(HAS_PYTHIA8),true)
-DELPHES_OBJ +=  \
-	
-endif
 
 endif
@@ -381,5 +361,10 @@
 	display/DisplayLinkDef.h \
 	display/DelphesDisplay.h \
-	display/DelphesCaloData.h
+	display/DelphesCaloData.h \
+	display/DelphesBranchElement.h \
+	display/Delphes3DGeometry.h \
+	display/DelphesEventDisplay.h \
+	display/DelphesHtmlSummary.h \
+	display/DelphesPlotSummary.h
 DisplayDict$(PcmSuf): \
 	tmp/display/DisplayDict$(PcmSuf) \
@@ -1235,4 +1220,28 @@
 	display/DelphesDisplay.$(SrcSuf) \
 	display/DelphesDisplay.h
+tmp/display/DelphesPlotSummary.$(ObjSuf): \
+	display/DelphesPlotSummary.$(SrcSuf) \
+	display/DelphesPlotSummary.h
+tmp/display/DelphesBranchElement.$(ObjSuf): \
+	display/DelphesBranchElement.$(SrcSuf) \
+	display/DelphesBranchElement.h \
+	classes/DelphesClasses.h
+tmp/display/DelphesEventDisplay.$(ObjSuf): \
+	display/DelphesEventDisplay.$(SrcSuf) \
+	external/ExRootAnalysis/ExRootConfReader.h \
+	external/ExRootAnalysis/ExRootTreeReader.h \
+	display/DelphesCaloData.h \
+	display/DelphesBranchElement.h \
+	display/Delphes3DGeometry.h \
+	display/DelphesEventDisplay.h \
+	classes/DelphesClasses.h
+tmp/display/DelphesHtmlSummary.$(ObjSuf): \
+	display/DelphesHtmlSummary.$(SrcSuf) \
+	display/DelphesHtmlSummary.h
+tmp/display/Delphes3DGeometry.$(ObjSuf): \
+	display/Delphes3DGeometry.$(SrcSuf) \
+	display/Delphes3DGeometry.h \
+	external/ExRootAnalysis/ExRootConfReader.h \
+	classes/DelphesClasses.h
 tmp/display/DelphesCaloData.$(ObjSuf): \
 	display/DelphesCaloData.$(SrcSuf) \
@@ -1240,4 +1249,9 @@
 DISPLAY_OBJ +=  \
 	tmp/display/DelphesDisplay.$(ObjSuf) \
+	tmp/display/DelphesPlotSummary.$(ObjSuf) \
+	tmp/display/DelphesBranchElement.$(ObjSuf) \
+	tmp/display/DelphesEventDisplay.$(ObjSuf) \
+	tmp/display/DelphesHtmlSummary.$(ObjSuf) \
+	tmp/display/Delphes3DGeometry.$(ObjSuf) \
 	tmp/display/DelphesCaloData.$(ObjSuf)
 
@@ -1461,4 +1475,8 @@
 	@touch $@
 
+display/DelphesBranchElement.h: \
+	display/DelphesCaloData.h
+	@touch $@
+
 external/fastjet/internal/DynamicNearestNeighbours.hh: \
 	external/fastjet/internal/numconsts.hh
@@ -1500,4 +1518,12 @@
 	@touch $@
 
+display/DelphesEventDisplay.h: \
+	external/ExRootAnalysis/ExRootTreeReader.h \
+	display/DelphesDisplay.h \
+	display/Delphes3DGeometry.h \
+	display/DelphesHtmlSummary.h \
+	display/DelphesPlotSummary.h
+	@touch $@
+
 modules/TauTagging.h: \
 	classes/DelphesModule.h
@@ -1584,4 +1610,8 @@
 modules/Hector.h: \
 	classes/DelphesModule.h
+	@touch $@
+
+display/DelphesPlotSummary.h: \
+	external/ExRootAnalysis/ExRootTreeReader.h
 	@touch $@
 
Index: doc/genMakefile.tcl
===================================================================
--- doc/genMakefile.tcl	(revision c3c9ac56bcd38b9487ed3bdd295d5b9c0606f3e6)
+++ doc/genMakefile.tcl	(revision f6b6ee7f127179b618ac5b4e3d7440af180c9dc1)
@@ -208,23 +208,23 @@
 CXXFLAGS += $(ROOTCFLAGS) -Wno-write-strings -D_FILE_OFFSET_BITS=64 -DDROP_CGAL -I. -Iexternal -Iexternal/tcl
 DELPHES_LIBS = $(shell $(RC) --libs) -lEG $(SYSLIBS)
-DISPLAY_LIBS = $(shell $(RC) --evelibs) $(SYSLIBS)
+DISPLAY_LIBS = $(shell $(RC) --evelibs) -lGuiHtml  $(SYSLIBS)
 
 ifneq ($(CMSSW_FWLITE_INCLUDE_PATH),)
 HAS_CMSSW = true
 CXXFLAGS += -std=c++0x -I$(subst :, -I,$(CMSSW_FWLITE_INCLUDE_PATH))
-DELPHES_LIBS += -L$(subst include,lib,$(subst :, -L,$(CMSSW_FWLITE_INCLUDE_PATH)))
+OPT_LIBS += -L$(subst include,lib,$(subst :, -L,$(CMSSW_FWLITE_INCLUDE_PATH)))
 ifneq ($(CMSSW_RELEASE_BASE),)
 CXXFLAGS += -I$(CMSSW_RELEASE_BASE)/src
 endif
 ifneq ($(LD_LIBRARY_PATH),)
-DELPHES_LIBS += -L$(subst include,lib,$(subst :, -L,$(LD_LIBRARY_PATH)))
-endif
-DELPHES_LIBS += -lGenVector -lFWCoreFWLite -lDataFormatsFWLite -lDataFormatsPatCandidates -lDataFormatsLuminosity -lSimDataFormatsGeneratorProducts -lCommonToolsUtils
+OPT_LIBS += -L$(subst include,lib,$(subst :, -L,$(LD_LIBRARY_PATH)))
+endif
+OPT_LIBS += -lGenVector -lFWCoreFWLite -lDataFormatsFWLite -lDataFormatsPatCandidates -lDataFormatsLuminosity -lSimDataFormatsGeneratorProducts -lCommonToolsUtils
 endif
 
 ifneq ($(PROMC),)
 HAS_PROMC = true
-CXXFLAGS += -I$(PROMC)/include
-DELPHES_LIBS += -L$(PROMC)/lib -lprotoc -lprotobuf -lprotobuf-lite -lcbook -lz
+CXXFLAGS += -I$(PROMC)/include -I$(PROMC)/src
+OPT_LIBS += -L$(PROMC)/lib -lpromc -lprotoc -lprotobuf -lprotobuf-lite -lcbook -lz
 endif
 
@@ -232,12 +232,15 @@
 HAS_PYTHIA8 = true
 CXXFLAGS += -I$(PYTHIA8)/include
-DELPHES_LIBS += -L$(PYTHIA8)/lib -lpythia8 -lLHAPDF -lgfortran -lz
+OPT_LIBS += -L$(PYTHIA8)/lib -lpythia8 -lLHAPDF -lgfortran -lz
 else
 ifneq ($(PYTHIA8DATA),)
 HAS_PYTHIA8 = true
 CXXFLAGS += -I$(PYTHIA8DATA)/../include
-DELPHES_LIBS += -L$(PYTHIA8DATA)/../lib -lpythia8 -lLHAPDF -lgfortran -lz
-endif
-endif
+OPT_LIBS += -L$(PYTHIA8DATA)/../lib -lpythia8 -lLHAPDF -lgfortran -lz
+endif
+endif
+
+DELPHES_LIBS += $(OPT_LIBS)
+DISPLAY_LIBS += $(OPT_LIBS)
 
 ###
@@ -268,5 +271,4 @@
 puts {ifeq ($(HAS_PROMC),true)}
 executableDeps {readers/DelphesProMC.cpp}
-sourceDeps {DELPHES} {external/ProMC/*.cc}
 puts {endif}
 puts {}
Index: examples/Example1.py
===================================================================
--- examples/Example1.py	(revision f6b6ee7f127179b618ac5b4e3d7440af180c9dc1)
+++ examples/Example1.py	(revision f6b6ee7f127179b618ac5b4e3d7440af180c9dc1)
@@ -0,0 +1,60 @@
+#!/usr/bin/env python
+
+import sys
+
+import ROOT
+
+if len(sys.argv) < 2:
+  print " Usage: Example1.py input_file"
+  sys.exit(1)
+
+ROOT.gSystem.Load("libDelphes")
+
+inputFile = sys.argv[1]
+
+# Create chain of root trees
+chain = ROOT.TChain("Delphes")
+chain.Add(inputFile)
+
+# Create object of class ExRootTreeReader
+treeReader = ROOT.ExRootTreeReader(chain)
+numberOfEntries = treeReader.GetEntries()
+
+# Get pointers to branches used in this analysis
+branchJet = treeReader.UseBranch("Jet")
+branchElectron = treeReader.UseBranch("Electron")
+
+# Book histograms
+histJetPT = ROOT.TH1F("jet_pt", "jet P_{T}", 100, 0.0, 100.0)
+histMass = ROOT.TH1F("mass", "M_{inv}(e_{1}, e_{2})", 100, 40.0, 140.0)
+
+# Loop over all events
+for entry in range(0, numberOfEntries):
+  # Load selected branches with data from specified event
+  treeReader.ReadEntry(entry)
+
+  # If event contains at least 1 jet
+  if branchJet.GetEntries() > 0:
+    # Take first jet
+    jet = branchJet.At(0)
+    
+    # Plot jet transverse momentum
+    histJetPT.Fill(jet.PT)
+    
+    # Print jet transverse momentum
+    print jet.PT
+
+  # If event contains at least 2 electrons
+  if branchElectron.GetEntries() > 1:
+    # Take first two electrons
+    elec1 = branchElectron.At(0)
+    elec2 = branchElectron.At(1)
+
+    # Plot their invariant mass
+    histMass.Fill(((elec1.P4()) + (elec2.P4())).M())
+
+# Show resulting histograms
+histJetPT.Draw()
+histMass.Draw()
+
+raw_input("Press Enter to continue...")
Index: modules/ParticlePropagator.cc
===================================================================
--- modules/ParticlePropagator.cc	(revision c3c9ac56bcd38b9487ed3bdd295d5b9c0606f3e6)
+++ modules/ParticlePropagator.cc	(revision f6b6ee7f127179b618ac5b4e3d7440af180c9dc1)
@@ -158,5 +158,5 @@
     if(TMath::Abs(q) < 1.0E-9 || TMath::Abs(fBz) < 1.0E-9)
     {
-      // solve pt2*t^2 + 2*(px*x + py*y)*t + (fRadius2 - x*x - y*y) = 0
+      // solve pt2*t^2 + 2*(px*x + py*y)*t - (fRadius2 - x*x - y*y) = 0
       tmp = px*y - py*x;
       discr2 = pt2*fRadius2 - tmp*tmp;
Index: modules/PileUpMergerPythia8.cc
===================================================================
--- modules/PileUpMergerPythia8.cc	(revision c3c9ac56bcd38b9487ed3bdd295d5b9c0606f3e6)
+++ modules/PileUpMergerPythia8.cc	(revision f6b6ee7f127179b618ac5b4e3d7440af180c9dc1)
@@ -132,5 +132,5 @@
     dphi = gRandom->Uniform(-TMath::Pi(), TMath::Pi());
 
-    for(i = 0; i < fPythia->event.size(); ++i)
+    for(i = 1; i < fPythia->event.size(); ++i)
     {
       Pythia8::Particle &particle = fPythia->event[i];
Index: readers/DelphesProMC.cpp
===================================================================
--- readers/DelphesProMC.cpp	(revision c3c9ac56bcd38b9487ed3bdd295d5b9c0606f3e6)
+++ readers/DelphesProMC.cpp	(revision f6b6ee7f127179b618ac5b4e3d7440af180c9dc1)
@@ -47,7 +47,7 @@
 #include "ExRootAnalysis/ExRootProgressBar.h"
 
-#include "ProMC/ProMC.pb.h"
-#include "ProMC/ProMCBook.h"
-#include "ProMC/ProMCHeader.pb.h"
+#include "ProMC.pb.h"
+#include "ProMCBook.h"
+#include "ProMCHeader.pb.h"
 
 using namespace std;
@@ -55,7 +55,8 @@
 //---------------------------------------------------------------------------
 
-void ConvertInput(ProMCEvent &event, ExRootTreeBranch *branch, DelphesFactory *factory,
-  TObjArray *allParticleOutputArray, TObjArray *stableParticleOutputArray, TObjArray *partonOutputArray,
-  TStopwatch *readStopWatch, TStopwatch *procStopWatch)
+void ConvertInput(ProMCEvent &event, double momentumUnit, double positionUnit,
+  ExRootTreeBranch *branch, DelphesFactory *factory,
+  TObjArray *allParticleOutputArray, TObjArray *stableParticleOutputArray,
+  TObjArray *partonOutputArray, TStopwatch *readStopWatch, TStopwatch *procStopWatch)
 {
   Int_t i;
@@ -107,6 +108,13 @@
     pid = mutableParticles->pdg_id(i);
     status = mutableParticles->status(i);
-    px = mutableParticles->px(i); py = mutableParticles->py(i); pz = mutableParticles->pz(i); mass = mutableParticles->mass(i);
-    x = mutableParticles->x(i); y = mutableParticles->y(i); z = mutableParticles->z(i); t = mutableParticles->t(i);
+
+    px = mutableParticles->px(i)/momentumUnit;
+    py = mutableParticles->py(i)/momentumUnit;
+    pz = mutableParticles->pz(i)/momentumUnit;
+    mass = mutableParticles->mass(i)/momentumUnit;
+    x = mutableParticles->x(i)/positionUnit;
+    y = mutableParticles->y(i)/positionUnit;
+    z = mutableParticles->z(i)/positionUnit;
+    t = mutableParticles->t(i)/positionUnit;
 
     candidate = factory->NewCandidate();
@@ -172,4 +180,5 @@
   Int_t i;
   Long64_t eventCounter, numberOfEvents;
+  double momentumUnit = 1.0, positionUnit = 1.0;
 
   if(argc < 4)
@@ -224,4 +233,11 @@
       inputFile = new ProMCBook(argv[i], "r");
 
+      ProMCHeader header = inputFile->getHeader();
+
+      momentumUnit = static_cast<double>(header.momentumunit());
+      positionUnit = static_cast<double>(header.lengthunit());
+
+
+
       if(inputFile == NULL)
       {
@@ -248,7 +264,8 @@
 
         procStopWatch.Start();
-        ConvertInput(event, branchEvent, factory,
-          allParticleOutputArray, stableParticleOutputArray, partonOutputArray,
-          &readStopWatch, &procStopWatch);
+        ConvertInput(event, momentumUnit, positionUnit,
+          branchEvent, factory,
+          allParticleOutputArray, stableParticleOutputArray,
+          partonOutputArray, &readStopWatch, &procStopWatch);
         modularDelphes->ProcessTask();
         procStopWatch.Stop();
Index: readers/DelphesProMC.py
===================================================================
--- readers/DelphesProMC.py	(revision c3c9ac56bcd38b9487ed3bdd295d5b9c0606f3e6)
+++ readers/DelphesProMC.py	(revision f6b6ee7f127179b618ac5b4e3d7440af180c9dc1)
@@ -134,5 +134,5 @@
 ################################################################################
 
-if len(sys.argv) < 2:
+if len(sys.argv) < 4:
   print " Usage: DelphesProMC.py config_file output_file input_file(s)"
   sys.exit(1)
Index: readers/DelphesPythia8.cpp
===================================================================
--- readers/DelphesPythia8.cpp	(revision c3c9ac56bcd38b9487ed3bdd295d5b9c0606f3e6)
+++ readers/DelphesPythia8.cpp	(revision f6b6ee7f127179b618ac5b4e3d7440af180c9dc1)
@@ -89,5 +89,5 @@
   pdg = TDatabasePDG::Instance();
 
-  for(i = 0; i < pythia->event.size(); ++i)
+  for(i = 1; i < pythia->event.size(); ++i)
   {
     Pythia8::Particle &particle = pythia->event[i];
